/* © 2017 Playful Invention Company */

var Block= function(type){
	this.setBlockSpecs(type);
	this.connections = new Array(this.dockCount());
}

Block.prototype.findLast = function(){
	var next = this.connections[this.connections.length-1];
 	if  (next == null)  return this;
 	return next.findLast();
 }

Block.prototype.addArg = function(type){
 	var next = this.connections[this.connections.length-1];
	this.connections[this.connections.length-1] = undefined;
	this.connections.push(next);	
	this.setBlockSpecs(type);
	this.setText(this.value);
}

Block.prototype.removeArg = function(type, n){
 	this.connections.splice(n,1);
	this.setBlockSpecs(type);
	this.setText(this.value);
}

Block.prototype.removeAllArgs = function(){
 	this.connections.splice(1, this.connections.length-2);
	this.setBlockSpecs('procedure');
	this.setText(this.value);
}

 Block.prototype.setBlockSpecs = function(type){
 	this.type = type;
	var ts = type.split(':');
	this.basetype = ts[0];	
	this.fcn = Turtle['prim_'+this.basetype];
	var suffix = '';
	if(ts[0]=='start') suffix=ts.length-1;
	if(ts[0]=='procedure') suffix=ts.length-1;
	this.alias =  this.basetype+suffix;
	this.info = Defs.blockinfo[this.basetype+suffix];
}

Block.prototype.argn = function(){return this.type.split(':').length-1;}
 
Block.prototype.docks = function (){return Defs.docks[this.info.docktype];}
Block.prototype.dockCount = function (){return Defs.docks[this.info.docktype].length;}
Block.prototype.lastDock = function (){return this.connections[this.dockCount()-1];}
	
Block.prototype.setText = function (text){
	this.value = text;
}

Block.prototype.dockCount = function (){return Defs.docks[this.info.docktype].length;}

 Block.prototype.disconnect = function(){
	if(this.connections[0]==undefined) return;
	var you = this.connections[0];
	you.connections[you.connections.indexOf(this)] = undefined;
	this.connections[0] = undefined;
}

Block.prototype.addDefaultArgs = function (p){
	var args  = this.info.args;
	if (!args &&  (args != 0)) return;
  var defaults  = (Number(args).toString() != 'NaN') || (Number(args) == 0) ? [args] : args;
	var docks = this.docks();
	var ndock = Defs.docks['input'][0];
	var argtype = this.docks()[0][0] == "unavailable" ? "arg" : "number";
	for(var i=0;i<defaults.length;i++){
		if (!this.connections[i+1]) {
			var a = new Block(argtype);
			a.setText(defaults[i]);
			this.connections[i+1] = a;
			a.connections[0] = this;
		}
	}
}

Block.prototype.hasStop = function(){
	if (this.type == 'stop') return true;
	var checkinside =  ['repeat', 'if', 'ifelse', 'forever'];
	var positions = [[2],[2],[2,3], [1]];
	var next = this;
	while (next) {
		var idx = checkinside.indexOf(next.type);
		if (idx > -1) {
			var pos = positions[idx];
			for (var i=0; i < pos.length; i++){
				var n = pos[i];
				if (next.connections[n] != undefined) {
					var b  = next.connections[n];
				 	var state =  b.hasStop();
		  		if (state) return true;
				}
			}
		}
		if (next.type == "stop") return true;
		next = next.connections[next.connections.length-1];		
	}
	return next ? next.op == "stop" : false;
}

