
PathTool.getOutline = function (settings, svg) {
	var el = SVG.top(700,560);
	PathTool.getOutlineStroke(settings, svg, el);
	return SVG.toString(el);
}

// old paula

PathTool.getOutlineStroke = function (settings, svg, el) {
	for (var i = 0; i <  svg.childElementCount; i++) {
		var elem = svg.childNodes[i];
		if (elem.id == "background") continue;
		console.log (elem.tagName);
		switch (elem.tagName.toLowerCase()) {
			case "g":
				PathTool.getOutlineStroke(settings, elem, el);
				break;
			case "circle":
				var clone = SVG.getClone(elem);
 				var attr = {"fill": 'none', "stroke": settings.stroke, "stroke-width":  settings.pensize,
				"stroke-miterlimit": 10, "stroke-linecap": "round", "stroke-linejoin": "round"};
				for (var val in attr) clone.setAttribute(val, attr[val]);
				el.appendChild(clone);
				break;
			case "path":
				PathTool.expand(el, elem.getAttribute("d"), elem.getAttribute("stroke-width")/2);		
				var clone = SVG.getClone(elem);
 				var attr = {"fill": 'none', "stroke": '#ffe300', "stroke-width": 1,
				"stroke-miterlimit": 10, "stroke-linecap": "round", "stroke-linejoin": "round"};
				for (var val in attr) clone.setAttribute(val, attr[val]);
				el.appendChild(clone);
				
				break;
		}	
	}
}


PathTool.expand=function(el, d, pensize){
	var commands = PathTool.getCommandList(d);
	if (!commands) return d;
	PathTool.looseEnd = {};
	PathTool.inpath = "";
	PathTool.outpath = "";
	for (var i = 0; i < commands.length ; i++) PathTool.expandCommand(el, commands[i], pensize);
	PathTool.closePath(el, pensize);
}

PathTool.closePath=function(el, pensize){
	if (!PathTool.looseEnd["startinner"]) return
	var before = PathTool.looseEnd["startinner"];
	var here = PathTool.looseEnd["startouter"];
	var str = "M"+before.x+","+before.y;
	str += PathTool.calculateTip(before, here, pensize);
	str += PathTool.outpath;
	str += PathTool.calculateTip(PathTool.looseEnd["endouter"], PathTool.looseEnd["endinner"], pensize);
	str += PathTool.inpath;
	var attr = {"fill": 'none', "stroke": '#00fee3', "stroke-width":  1,
			"stroke-miterlimit": 10, "stroke-linecap": "round", "stroke-linejoin": "round"};
	attr ["d"]  = str;
	SVG.addChild(el, 'path', attr);
	PathTool.looseEnd = {};
	PathTool.inpath = "";
	PathTool.outpath = "";
}

PathTool.expandCommand=function(el, cmd, ps){
	var key = cmd[0];
	PathTool.dispatchExpandCmd[key](el, cmd, ps);
}

// moves
PathTool.startPath=function(el, cmd, ps){
	if (PathTool.looseEnd["startinner"])  PathTool.closePath(el, ps);
	PathTool.endp = {x: cmd[1], y: cmd[2]};
	PathTool.startp = PathTool.endp;
}

PathTool.expandLine = function(el, cmd, ps){
	var pt =  {x: cmd[1], y: cmd[2]};	
	var corners = PathTool.calculateOffsets(PathTool.endp, pt, ps);	
	PathTool.inpath = "L"+corners.startin.x+","+corners.startin.y + PathTool.inpath;
//	PathTool.inpath = "M"+corners.endin.x+","+corners.endin.y + PathTool.inpath; 
//	PathTool.outpath += "M"+corners.startout.x+","+corners.startout.y;
	PathTool.outpath += "L"+corners.endout.x+","+corners.endout.y;
	if (PathTool.startp == PathTool.endp) {
		PathTool.looseEnd ["startinner"] = corners.startin;
		PathTool.looseEnd ["startouter"] = corners.startout;
	}
	PathTool.looseEnd ["endinner"] = corners.endin;
	PathTool.looseEnd ["endouter"] = corners.endout;				
	PathTool.endp = pt;
}

PathTool.calculateTip = function(before, here, r){
	var v1 = Vector.diff (here, before);
	var heading =  180 - ((Math.atan2(v1.y, v1.x) * 180) / Math.PI); 
	var largArcFlag = Math.abs(heading) % 360 > 180 ? 1 : 0;
	return ["A", r, r, 0, 0, 1, here.x, here.y].join(" ");		
}

PathTool.calculateOffsets = function(before, here, size){
	var v1 = Vector.diff (here, before); 
	var pt = Vector.scale(v1, 0.5);
	var perp = Vector.perp(pt);
	var unitvector = Vector.norm (perp);
	var pt1 = Vector.sum (before, Vector.scale(unitvector, size));
	var pt2 = Vector.sum (before, Vector.scale(unitvector, -size));
	var pt3 = Vector.sum (here, Vector.scale(unitvector, size));
	var pt4 = Vector.sum (here, Vector.scale(unitvector, -size));
	pt1.here =  {x: here.x, y: here.y};
	pt2.here =  {x: here.x, y: here.y};
	return {startin: pt1, startout: pt2, endin: pt3, endout: pt4};
}

PathTool.getAngles = function (a, b, c){
		var cosa = ((b * b) + (c * c) - (a * a)) / ( 2 * b * c); // turtle angle comand
		var cosb = ((c * c) + (a * a) - (b * b )) / ( 2 * c * a); // the other side
		var cosc = ((a * a) + (b * b) - (c * c)) / ( 2 * a * b); // one side
		return {A: cos2degree(cosa),  C: cos2degree(cosc), B: cos2degree(cosb)};
}

function cos2degree(val) { return Number(deg(Math.acos(val)).toPrecision(12));}

PathTool.expandArc = function(el, cmd, size){
	var pt =  {x: cmd[6], y: cmd[7]};	
	var v1 = Vector.diff(pt, PathTool.endp);
	var a = Vector.len(v1);
	var b = cmd[1];
	var c = cmd[2];
	var r = b;
	var angles = PathTool.getAngles(a,b,c);
	var heading = 90+Number((Math.atan2(v1.y, v1.x) * 180 / Math.PI).toFixed(12));	
	var swipeflag =  cmd[5] == 0 ? 1 : 0;
	// in path
	var headingtocenter = cmd[5] == 0  ? getAngle (heading - angles.B) : getAngle (heading + angles.B) ;
	var angles = PathTool.getAngles(a,b,c);
	var heading = getAngle( 90 + fromDelta(v1));		
	var swipeflag =  cmd[5] == 0 ? 1 : 0;
	// in path
	var starth = getAngle (heading - angles.B);
	var endh = getAngle (heading + angles.A - 180);
	var flag = cmd[5] == 0;
	var headingtocenter = flag  ? getAngle (heading - angles.B) : getAngle (heading + angles.B) ;

	var center =  getCoor(PathTool.endp, headingtocenter,  r);
/*	 // for debugging
	PathTool.outpath += "M"+PathTool.endp.x+","+PathTool.endp.y;
	PathTool.outpath += "L"+center.x+","+center.y;
	PathTool.outpath += "L"+pt.x+","+pt.y;
	PathTool.outpath += "L"+PathTool.endp.x+","+PathTool.endp.y;
*/
	var sd = Vector.diff(center, PathTool.endp);
	var ed = Vector.diff(center, pt);
	var sh =  getAngle (90 + fromDelta(sd));
	var eh =  getAngle (90 + fromDelta(ed));

	var opposite = cmd[5] == 0 ? 1 :  0;
	var dir = flag ? 1 : -1;
	var pts1 = getPoints(PathTool.endp, pt, sh, eh, size);
	var pts2 = getPoints(PathTool.endp, pt, getAngle (sh + 180), getAngle (eh + 180), size);

	var acmd2 = ["A", r - size, r - size, cmd[3], cmd[4] , cmd[5], pts1.end.x, pts1.end.y]; // good
	var am3 =  "M"+pts1.start.x+","+pts1.start.y;
	
	var bcmd = ["A", r + size, r + size, cmd[3], cmd[4] , cmd[5], pts2.end.x, pts2.end.y]; // good
	var am2 = "M"+pts2.start.x+","+pts2.start.y; 
	
	var bcmd2 = ["A", r + size, r + size, cmd[3], cmd[4] ,opposite, pts2.start.x, pts2.start.y];
	var am4 =  "M"+pts2.end.x+","+ pts2.end.y ; 
	
	var acmd = ["A", r - size, r - size, cmd[3], cmd[4] , opposite, pts1.start.x, pts1.start.y];
	var am1 = "M"+pts1.end.x+","+pts1.end.y; 
	
	
	
	if (flag) {
		PathTool.inpath = bcmd2.join(" ") + PathTool.inpath;	
		PathTool.looseEnd ["endinner"] = pts2.end;
		PathTool.looseEnd ["endouter"] = pts1.end;
		if (PathTool.startp == PathTool.endp) {
		//	PathTool.outpath += am3;
				PathTool.looseEnd ["startinner"] = pts2.start;
				PathTool.looseEnd ["startouter"] = pts1.start;
		}
		PathTool.outpath += acmd2.join(" ");
		//	console.log ("--> " +am4 + ' ' + bcmd2.join(" "));
	}
	else {
		PathTool.inpath = acmd.join(" ") + PathTool.inpath;
		PathTool.looseEnd ["endinner"] = pts1.end;
		PathTool.looseEnd ["endouter"] = pts2.end;
		if (PathTool.startp == PathTool.endp) {
				PathTool.looseEnd ["startinner"] = pts1.start;
				PathTool.looseEnd ["startouter"] = pts2.start;
		}
		PathTool.outpath += bcmd.join(" ");
	//	console.log ("!!!! " +am1 + ' ' + acmd.join(" "));
	}

	function fromDelta(pt) {return Number((Math.atan2(pt.y, pt.x) * 180 / Math.PI).toFixed(12))};
	function getAngle (a) {return (a < 0 ? 360 + a : a).mod(360);}
	function getCoor (pt, a, dist) {return {x: pt.x +dist*sindeg(a), y: pt.y - dist*cosdeg(a)};}	
	function getPoints (sp, ep, sh, eh, size){return {start:  getCoor(sp, sh, size), end: getCoor(ep, eh, size)};}
	PathTool.endp = pt;
}

PathTool.getLastPathCommand=function(spr){
	var d = spr.getAttribute("d");
	var commands = d.match(/[A-DF-Za-df-z][^A-Za-df-z]*/g);
	return (commands.length > 0) ? commands[commands.length - 1].charAt(0) : null;
}

PathTool.isCloseDPath=function(elem){
	if (elem.tagName != "path") return true;
	if (PathTool.isCompoundPath(elem)) return true;
	var d = elem.getAttribute("d");
	var commands = d.match(/[A-DF-Za-df-z][^A-Za-df-z]*/g);
	if (commands.length < 2)  return false;
	var lastCmd =  commands[commands.length - 1];
	if (lastCmd.charAt(0) == "z") return true;
	if (commands.length < 4)  return false;
	var firstCmd =  commands[0];

	if (lastCmd.charAt(0).toLocaleUpperCase() != lastCmd.charAt(0))return false;
	var firstdata =  PathTool.splitNumericArgs(firstCmd.substr(1, firstCmd.length));
	var lastdata =  PathTool.splitNumericArgs(lastCmd.substr(1, lastCmd.length));

	if (firstdata.length < 2) return false;
	if (lastdata.length < 2) return false;

	var pt1 = {x: firstdata[firstdata.length -2], y: firstdata[firstdata.length -1]};
	var pt2 = {x: lastdata[lastdata.length -2], y: lastdata[lastdata.length -1]};
	return Vector.len(Vector.diff(pt1, pt2)) < 10;
}

PathTool.isCompoundPath = function(shape){
	var paths = shape.getAttribute("d").match(/[M][^M]*/g);
	if (!paths) return false;
	return  paths.length > 1;
}


PathTool.splitNumericArgs=function(str) {
	var res=[];
	if (!str) return res;
	var list = str.match(/(?:\+|-)?\d+(?:\.\d+)?(?:e(?:\+|-)?\d+)?/g);
	for (var i = 0; i < list.length ; i++) res.push(Number(list[i]));
	return res;
}


PathTool.dispatchExpandCmd = {'M': PathTool.startPath, "L": PathTool.expandLine,'A': PathTool.expandArc, "z": PathTool.closePath, "Z": PathTool.closePath};
