/* © 2017 Playful Invention Company */

Turtle = function() {};
Turtle.xcor;
Turtle.ycor;
Turtle.heading = 0;
Turtle.color=0;
Turtle.shade=50;
Turtle.pendown= true;
Turtle.pensize = 4;
Turtle.size = 120;
Turtle.uisize = 120*920/700;
Turtle.seed = (new Date).getTime();
Turtle.startseed = Turtle.seed;

// Paula

Turtle.path = "";
Turtle.svg = undefined;
Turtle.svgGroup = undefined;
Turtle.fillpathSVG = undefined;

Turtle.colors = [
	0xFF0000, 0xFF0D00, 0xFF1A00, 0xFF2600, 0xFF3300, 0xFF4000, 0xFF4D00, 0xFF5900, 0xFF6600, 0xFF7300, 
	0xFF8000, 0xFF8C00, 0xFF9900, 0xFFA600, 0xFFB300, 0xFFBF00, 0xFFCC00, 0xFFD900, 0xFFE600, 0xFFF200, 
	0xFFFF00, 0xE6FF00, 0xCCFF00, 0xB3FF00, 0x99FF00, 0x80FF00, 0x66FF00, 0x4DFF00, 0x33FF00, 0x1AFF00, 
	0x00FF00, 0x00FF0D, 0x00FF1A, 0x00FF26, 0x00FF33, 0x00FF40, 0x00FF4D, 0x00FF59, 0x00FF66, 0x00FF73, 
	0x00FF80, 0x00FF8C, 0x00FF99, 0x00FFA6, 0x00FFB3, 0x00FFBF, 0x00FFCC, 0x00FFD9, 0x00FFE6, 0x00FFF2, 
	0x00FFFF, 0x00F2FF, 0x00E6FF, 0x00D9FF, 0x00CCFF, 0x00BFFF, 0x00B3FF, 0x00A6FF, 0x0099FF, 0x008CFF, 
	0x0080FF, 0x0073FF, 0x0066FF, 0x0059FF, 0x004DFF, 0x0040FF, 0x0033FF, 0x0026FF, 0x001AFF, 0x000DFF, 
	0x0000FF, 0x0D00FF, 0x1A00FF, 0x2600FF, 0x3300FF, 0x4000FF, 0x4D00FF, 0x5900FF, 0x6600FF, 0x7300FF, 
	0x8000FF, 0x8C00FF, 0x9900FF, 0xA600FF, 0xB300FF, 0xBF00FF, 0xCC00FF, 0xD900FF, 0xE600FF, 0xF200FF, 
	0xFF00FF, 0xFF00E6, 0xFF00CC, 0xFF00B3, 0xFF0099, 0xFF0080, 0xFF0066, 0xFF004D, 0xFF0033, 0xFF001A, 
	0xFF0000
];

Turtle.setup = function (){
	Turtle.svg =  SVG.top(700,560);
	Turtle.svgGroup =SVG.group(Turtle.svg, "imagepaths");
}

/////////////////////////
//
// Turtle
//
/////////////////////////

Turtle.prim_clean=function(b){Turtle.clean()}

Turtle.prim_forward =function(b){Turtle.forward(Runtime.getnum(b,1));}
	
Turtle.prim_back=function(b){Turtle.forward(-Runtime.getnum(b,1));}

Turtle.forward = function(n){
	if (Turtle.pendown && (n!=0)){
		if (Turtle.path == "") {
			var step = "M"+(Turtle.xcor+Runtime.xmax/2) +","+ (Runtime.ymax/2-Turtle.ycor);
			Turtle.path +=step;
		}
	}
	
	Turtle.xcor+=n*sindeg(Turtle.heading);
	Turtle.ycor+=n*cosdeg(Turtle.heading);
	
	if(Turtle.pendown){
		var sx=Turtle.xcor+Runtime.xmax/2, sy=Runtime.ymax/2-Turtle.ycor;
		if (n == 0) Turtle.drawDot(); // sx = (Turtle.xcor + 0.001) +Runtime.xmax/2;
		else  {
			var step = "L"+sx+","+ sy;
			Turtle.path +=step;	
			if (Turtle.fillpathSVG) Turtle.fillpathSVG+=step;
		}
	}
}

Turtle.getColor = function (){
	var c = Turtle.mergeColorShade(Turtle.color, Turtle.shade);
	return '#'+(c+0x1000000).toString(16).substring(1);	
}

Turtle.prim_right=function(b){Turtle.seth(Turtle.heading+Runtime.getnum(b,1));}
Turtle.prim_left=function(b){Turtle.seth(Turtle.heading-Runtime.getnum(b,1));}
Turtle.prim_seth=function(b){Turtle.seth(Runtime.getnum(b,1));}

Turtle.seth=function(a){
	Turtle.heading=a;
	Turtle.heading=Turtle.heading.mod(360);
}

Turtle.prim_setxy=function(b){
//	Turtle.drawSVGPath(Turtle.path, true);
	Turtle.xcor = Runtime.getnum(b,1);
	Turtle.ycor = Runtime.getnum(b,2);
	var sx=Turtle.xcor+Runtime.xmax/2, sy=Runtime.ymax/2-Turtle.ycor;
	Turtle.path += "M"+sx+","+sy;
	if (Turtle.fillpathSVG) Turtle.fillpathSVG += "M"+sx+","+sy;
}

Turtle.prim_arc=function(b){
	var a = Runtime.getnum(b,1);
	var r = Runtime.getnum(b,2);
	if(a==0) return;	
	if(r==0) {Turtle.seth(Turtle.heading+a); return;}
	if (Turtle.path == "") {
		var step = "M"+(Turtle.xcor+Runtime.xmax/2) +","+ (Runtime.ymax/2-Turtle.ycor);
		Turtle.path +=step;
	}
	var dir = a < 0 ? -1 : 1;
	var cmd = Turtle.getSVGarc (a, r, dir);
	Turtle.path+= cmd;
	if (Turtle.fillpathSVG) Turtle.fillpathSVG+=cmd;
	Turtle.setArcState(a,r, dir);
}

Turtle.getSVGarc = function (angle, r, dir){
	var a =  Math.abs(angle) == 360 ? 180* angle/Math.abs(angle) : angle;
	var sgn = r == 0 ?  1 : r/Math.abs(r);
	var ar = Math.abs(r);
	var h =Turtle.heading+a*sgn; 
	h = h.mod(360);
	var cx = Turtle.xcor+ar*cosdeg(Turtle.heading) * dir;
	var cy = Turtle.ycor-ar*sindeg(Turtle.heading) * dir;
	var sx=Runtime.xmax/2+Turtle.xcor, sy=Runtime.ymax/2-Turtle.ycor;
	var ex=Runtime.xmax/2+(cx-ar*cosdeg(h) * dir), ey=Runtime.ymax/2-(cy+ar*sindeg(h) * dir);
	var sweepFlag = sgn*(a/Math.abs(a)) > 0 ? 1 : 0;
	var largArcFlag = Math.abs(a) % 360 > 180 ? 1 : 0;
	var d = ["A", Math.abs(r*dir), Math.abs(r*dir), 0, largArcFlag, sweepFlag, ex, ey].join(" "); 
	if (angle == a) return d;
	var sx=Runtime.xmax/2+Turtle.xcor, sy=Runtime.ymax/2-Turtle.ycor;
	d += ["A", Math.abs(r*dir), Math.abs(r*dir), 0, largArcFlag, sweepFlag, sx, sy].join(" "); 
//	console.log (d);
	return d;
}

Turtle.setArcState = function (a, r, dir){
	var ar = Math.abs(r);
	var cx = Turtle.xcor+ar*cosdeg(Turtle.heading) * dir;
	var cy = Turtle.ycor-ar*sindeg(Turtle.heading) * dir;
	var sgn =  r == 0 ?  1 : r/Math.abs(r);
	Turtle.seth(Turtle.heading+a*sgn);
	Turtle.xcor = cx-ar*cosdeg(Turtle.heading) * dir;
	Turtle.ycor = cy+ar*sindeg(Turtle.heading) * dir;
//	console.log (Turtle.xcor + "  " + Turtle.ycor);
}

Turtle.prim_xcor=function(b){return Turtle.xcor;}
Turtle.prim_ycor=function(b){return Turtle.ycor;}
Turtle.prim_heading=function(b){return Turtle.heading;}

/////////////////////////
//
// Pen
//
/////////////////////////

Turtle.prim_fillscreen=function(b){
	var color = Runtime.getnum(b,1);
	var shade = Runtime.getnum(b,2);
	Turtle.fillscreen(color, shade); // #FAFAFA
}

Turtle.prim_pendown=function(){
	Turtle.pendown=true;
	var sx=Turtle.xcor+Runtime.xmax/2, sy=Runtime.ymax/2-Turtle.ycor;
	Turtle.path += "M"+sx+","+sy;
	if (Turtle.fillpathSVG) Turtle.fillpathSVG += "M"+sx+","+sy;	
}

Turtle.prim_penup=function(){
	Turtle.pendown=false;
	//Turtle.drawSVGPath(Turtle.path, true);
//	Turtle.drawSVG();
}

Turtle.drawSVG = function() {
	Turtle.drawSVGPath(Turtle.path, true);
	Turtle.path = "";
	if (Turtle.fillpathSVG &&  (Turtle.fillpathSVG!="")) {
		Turtle.fillpathSVG+="z";
		Turtle.drawSVGPath(Turtle.fillpathSVG, false);
		Turtle.fillpathSVG = undefined;
	}
}

Turtle.drawSVGPath = function(d, isStroke){
	if (d == "")  return;
	if (isStroke && (Turtle.pensize == 0)) return; 
	if ((d.indexOf ("L") < 0)  && (d.indexOf ("A") < 0)) return;
	var c = Turtle.getColor();	
  var attr = isStroke ? {"fill": 'none',"stroke":  c, "stroke-width":  Turtle.pensize,
			"stroke-miterlimit": 10, 'd': d,  "stroke-linecap": "round", "stroke-linejoin": "round"} : {"fill": c, 'd': d}
	var	base = document.createElementNS(SVG.svgns, "path");
	for (var val in attr) base.setAttribute(val, attr[val]);
	Turtle.svgGroup.appendChild(base);
}

Turtle.drawDot = function (){
	var hasFillPath = Turtle.fillpathSVG != undefined;
	Turtle.drawSVG();
	var tr =  Turtle.pensize / 2;
	var c = Turtle.getColor();	
	var sx=Turtle.xcor+Runtime.xmax/2, sy=Runtime.ymax/2-Turtle.ycor;
	var attr = {fill: c,  cx: sx, cy: sy, r: tr}
	SVG.addChild(Turtle.svgGroup, "circle", attr);
	if (hasFillPath) Turtle.fillpathSVG = "M"+sx+","+sy;
}

Turtle.prim_setcolor=function(b){
	Turtle.drawSVGPath(Turtle.path, true);
	Turtle.path = "";
	Turtle.color=Runtime.getnum(b,1);
}

Turtle.prim_setshade=function(b){
	Turtle.drawSVGPath(Turtle.path, true);
	Turtle.path = "";
	Turtle.shade=Runtime.getnum(b,1);
}

Turtle.prim_setpensize=function(b){
	Turtle.drawSVGPath(Turtle.path, true);
	Turtle.path = "";
	Turtle.pensize = Runtime.getnum(b,1);
}

Turtle.prim_startfill=function(){
	var sx=Turtle.xcor+Runtime.xmax/2, sy=Runtime.ymax/2-Turtle.ycor;
	Turtle.fillpathSVG = "M"+sx+","+sy;
}

Turtle.prim_endfill=function(){
	if (Turtle.fillpathSVG &&  (Turtle.fillpathSVG!="")) {
		Turtle.fillpathSVG+="z";
		Turtle.drawSVGPath(Turtle.fillpathSVG, false);
	}
	Turtle.fillpathSVG = undefined;
}

Turtle.prim_color=function(b){return Turtle.color;}
Turtle.prim_shade=function(b){return Turtle.shade;}
Turtle.prim_pensize=function(b){return Turtle.pensize;}

/////////////////////////
//
// Flow
//
/////////////////////////

Turtle.prim_wait=function(b){
	if(Runtime.waitendtime==undefined) Runtime.waitendtime = (new Date()).getTime() +Math.floor(Runtime.getnum(b,1)*100);
	if((new Date()).getTime()>Runtime.waitendtime) Runtime.waitendtime = undefined;
	else Runtime.thisBlock = b;
}

Turtle.prim_repeat=function(b){
	var n = Math.floor(Runtime.getnum(b,1));
	if(n<1) return;
	Runtime.stack.push(Runtime.thisBlock);
	Runtime.stack.push(n);
	Runtime.thisBlock = b.connections[2];
	Runtime.stack.push(Runtime.thisBlock);
	Runtime.stack.push(Runtime.repeatAgain);
}

Turtle.prim_hspace=function(b){}
Turtle.prim_vspace=function(b){}

Turtle.prim_forever=function(b){
	if(b.connections[1]==undefined) return;
	var stops = b.hasStop();
	if (!stops) {
		Maker.error="Can't process a forever block with no stop";
		Runtime.thisBlock = null;
		Runtime.stack = [];
	}
	else {
		Runtime.thisBlock = b.connections[1];
		Runtime.stack.push(Runtime.thisBlock);
		Runtime.stack.push(Runtime.foreverAgain);
	}
}

Turtle.prim_stop=function(b){
	Runtime.thisBlock = undefined;
	while((Runtime.stack.length>0)&&(Runtime.stack[Runtime.stack.length-1]!=Runtime.procDone)) Runtime.stack.pop();
}

Turtle.prim_if=function(b){
	var bool = Runtime.getbool(b,1);
	if(bool){
		Runtime.stack.push(Runtime.thisBlock);
		Runtime.stack.push(Runtime.ifDone);
		Runtime.thisBlock = b.connections[2];	
	}
}

Turtle.prim_ifelse=function(b){
	var bool = Runtime.getbool(b,1);
	if(bool){
		Runtime.stack.push(Runtime.thisBlock);
		Runtime.stack.push(Runtime.ifDone);
		Runtime.thisBlock = b.connections[2];	
	} else {
		Runtime.stack.push(Runtime.thisBlock);
		Runtime.stack.push(Runtime.ifDone);
		Runtime.thisBlock = b.connections[3];	
	}
}

Turtle.prim_print=function(b){}

/////////////////////////
//
// Numbers
//
/////////////////////////

Turtle.prim_number=function(b){return parseFloat(b.value);}


Turtle.prim_opar=function(b){return Runtime.getnum(b,1);}
Turtle.prim_cpar=function(b){}

Turtle.prim_plus=function(a,b){return a+b;}
Turtle.prim_minus=function(a,b){return a-b;}
Turtle.prim_product=function(a,b){return a*b;}
Turtle.prim_division=function(a,b){return (b!=0)?a/b:0;}
Turtle.prim_remainder=function(a,b){return a.mod(b);}

Turtle.prim_less=function(b){return Runtime.getnum(b,1)<Runtime.getnum(b,2);}
Turtle.prim_greater=function(b){return Runtime.getnum(b,1)>Runtime.getnum(b,2);}
Turtle.prim_equal=function(b){return Math.abs(Runtime.getnum(b,1)-Runtime.getnum(b,2))<1e-9;}

Turtle.prim_random=function(b){return Turtle.pickRandom(Runtime.getnum(b, 1), Runtime.getnum(b, 2));}
Turtle.prim_oneof=function(b){return Turtle.nextRandomDouble()<.5 ? Runtime.getnum(b, 1) : Runtime.getnum(b, 2);}


/////////////////////////
//
// My Blocks
//
/////////////////////////

Turtle.prim_procedure=function(b){
	if(Runtime.procs[b.value]==undefined){
		TA.setText('I dont know how to '+b.value);
		Runtime.stack = [];
		Runtime.thisBlock = undefined;	
		return;
	}
	var sig = b.type.split(':');
	var vals = [];
	for(var a=0;a<sig.length-1;a++) vals.push(Runtime.getnum(b, a+1));
	for(var i=1;i<sig.length;i++){
		var v = sig[i];
		Runtime.stack.push(Runtime.boxes[v]);
		Runtime.stack.push(v);
		Runtime.boxes[v] = vals[i-1];
	}
	Runtime.stack.push(sig.length-1);
	Runtime.stack.push(Runtime.thisBlock);
	Runtime.stack.push(Runtime.procDone);
	Runtime.thisBlock = Runtime.procs[b.value];
}

Turtle.prim_start=function(b){}

Turtle.prim_setglobal=function(b){
//	console.log ("prim_setglobal " +  b.value  + " " +  Runtime.getnum(b,1));
	Runtime.boxes[b.value] = Runtime.getnum(b,1);
}

Turtle.prim_global=function(b){
//	console.log ("prim_global " +  b.value  + " " + Runtime.boxes[b.value]); 
	return Runtime.boxes[b.value];
}

Turtle.prim_local=function(b){
	return Runtime.boxes[b.value];
}

/////////////////////////
//
//  Basic stuff
//
/////////////////////////

Turtle.move = function(){}

Turtle.screenLeft = function() {return -Turtle.size/2+(Turtle.xcor+Runtime.xmax/2)* Turtle.scale();}
Turtle.screenTop = function() {return -Turtle.size/2+(Runtime.ymax/2-Turtle.ycor)*Turtle.scale();}

Turtle.screenToX =  function(val) {return (val+Turtle.size/2)/Turtle.scale()-Runtime.xmax/2;}
Turtle.screenToY =  function(val) {return Runtime.ymax/2-(val+Turtle.size/2)/Turtle.scale(); }

Turtle.clean =  function(){
	Turtle.init();
	Turtle.fillscreen(-9999, 98); // #FAFAFA
}

Turtle.init = function(){
	var scale = 920/700;
	Turtle.xcor=0, Turtle.ycor=0, Turtle.heading=0;
	Turtle.color=0, Turtle.shade=50;
	Turtle.pensize = 4;
	Turtle.pendown = true;
	Turtle.fillpathSVG = undefined;
	Turtle.path = "";
}

Turtle.fillscreen=function(color, shade){
	while (Turtle.svg.childElementCount >  0) Turtle.svg.removeChild(Turtle.svg.childNodes[0]);
	Turtle.svgGroup = SVG.group(Turtle.svg, "imagepaths");
	var path = "M0,0L700,0L700,560L0,560z";
	var c = Turtle.mergeColorShade(color,shade);
	var cc = '#'+(c+0x1000000).toString(16).substring(1);	
  var attr = {"id": "background", "fill": cc, 'd': path};
	var	base = document.createElementNS(SVG.svgns, "path");
	for (var val in attr) base.setAttribute(val, attr[val]);
	Turtle.svgGroup.appendChild(base)
}

Turtle.scale =  function () { return cnv.width/700;}

/////////////////////////
//
// random
//
/////////////////////////


Turtle.pickRandom = function(a,b){
	ia = Math.floor(a);
	ib = Math.floor(b);
	if((a==ia)&&(b==ib)) return a+(Math.floor(Turtle.nextRandomDouble()*(b-a+1)));
	else return a+(Turtle.nextRandomDouble()*(b-a));
}

Turtle.nextRandomDouble = function (){
	var r1 = Turtle.nextRandom(26);
	var r2 = Turtle.nextRandom(27);
	return (r1*Math.pow(2,27)+r2)/Math.pow(2,53);	
}

Turtle.nextRandom = function(bits){
	var k = 0x5DEECE66D;
	var shift=1, mod=Math.pow(2,48);
	var part, res=0;
	for(var i=0;i<9;i++){
		part = (k%16)*Turtle.seed%mod*shift;
		res+=part;
		k = Math.floor(k/16);
		shift*=16; mod/=16;
	}
	res+=11; res%=Math.pow(2,48);
	Turtle.seed = res;
	return Math.floor(res/Math.pow(2,48-bits));
}



/////////////////////////
//
// Low Level
//
/////////////////////////

Turtle.mergeColorShade = function(color, shade){
	var sh = Math.abs(shade.mod(200));
	if(sh>100) sh = 200 - sh;
	if(color==-9999) return Turtle.blend(0x000000, 0xffffff, sh/100);
	var c = Turtle.colorFromNumber(color);
	if(sh==50) return c;
	else if (sh<50) return Turtle.blend(c, 0x000000, (50-sh)/60);
	else return Turtle.blend(c, 0xffffff, (sh-50)/53);
}

Turtle.colorFromNumber = function(c){
	var mc = c.mod(100);
	var ic = Math.floor(mc);
	var fract = mc - ic;
	return Turtle.blend(Turtle.colors[ic], Turtle.colors[ic+1], fract);
}

Turtle.blend = function(a, b, s){
	var ar=(a>>16)&0xff, ag=(a>>8)&0xff, ab=a&0xff; 
	var br=(b>>16)&0xff, bg=(b>>8)&0xff, bb=b&0xff; 
	var rr = Math.round(ar*(1-s)+br*s);
	var rg = Math.round(ag*(1-s)+bg*s);
	var rb = Math.round(ab*(1-s)+bb*s);
	return (rr<<16)+(rg<<8)+rb;
}

Turtle.setCtxColor = function(c){
	var cc = '#'+(c+0x1000000).toString(16).substring(1);
	Maker.ctx.strokeStyle = cc;
	Maker.ctx.fillStyle = cc; 
}

function rad(a){return a*2*Math.PI/360;}
function deg(a){return a*360/(2*Math.PI);}
function sindeg(x){return Math.sin(x*2*Math.PI/360);}
function cosdeg(x){return Math.cos(x*2*Math.PI/360);}
Number.prototype.mod = function(n) {return ((this%n)+n)%n;}

